Subject: Re: [6lowpan] #65: Deriving IIDs from Short Addresses

From: "Reddy, Joseph" <[email-masked]>
Date: Tue, 30 Mar 2010 12:13:50 -0500

Hi Jonathan

I prefer option 1. 
I still believe this should be paired with a 112 bit prefix and not 64-bit prefix as you  suggest

-Joseph

    On Mar 30, 2010, at 05:36, Jonathan Hui wrote:

    Typing ...::ff:fe00:xxxx is a bit ugly, granted.
    If we were designing 4944 from scratch, I would buy that argument.

    However, it was agreed in May 2007, and I'd like to see a better argument to change it incompatibly. 

AFAIK, there are only a handful of independent implementations that have tested interoperability to this day and even less with the use of short addresses. W.r.t. 6lowpan-hc there was ambiguity over whether or not to use the PAN ID in the IID. It seems that we need to change something to better achieve interoperability. There's already consensus to never include the PAN ID in the IID, so an update to Section 6 of RFC 4944 is already necessary.

I believe the vast majority of implementors are subscribed to this list. So which of the following options do people prefer?

1) IPv6 addrs that have the form aaaa::ff:fe00:xxxx.

2) IPv6 addrs that have the form aaaa::1:xxxx.

In both cases, the prefix and IID is 64 bits. At this point it's just a matter of how many zeros are involved. It's a minor point, so I wouldn't dwell on this issue too long.

--
Jonathan Hui

---

From: Jonathan Hui <[email-masked]>
Date: Tue, 30 Mar 2010 10:18:16 -0700

Hi Joseph,

I believe there was a strong reason for keeping the IID at 64 bits -  
because that's what the reset of the IPv6 addressing architecture  
tends to assume.

To drive the discussion, can you state why you prefer 'ff:fe'?  Simply  
to close to, but not exactly with RFC 4944?  As I stated before,  
trying to avoid global-scoped IEEE addresses is a non-issue since  
short addresses have local scope.

--
Jonathan Hui

On Mar 30, 2010, at 10:13 AM, Reddy, Joseph wrote:

> AFAIK, there are only a handful of independent implementations that  
> have tested interoperability to this day and even less with the use  
> of short addresses. W.r.t. 6lowpan-hc there was ambiguity over  
> whether or not to use the PAN ID in the IID. It seems that we need  
> to change something to better achieve interoperability. There's  
> already consensus to never include the PAN ID in the IID, so an  
> update to Section 6 of RFC 4944 is already necessary.
>
> I believe the vast majority of implementors are subscribed to this  
> list. So which of the following options do people prefer?
>
> In both cases, the prefix and IID is 64 bits. At this point it's  
> just a matter of how many zeros are involved. It's a minor point, so  
> I wouldn't dwell on this issue too long.
>
> --
> Jonathan Hui
>
> _______________________________________________
> 6lowpan mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/6lowpan

---

From: Daniel Gavelle <[email-masked]>
Date: Tue, 30 Mar 2010 18:47:27 +0100

Jonathan,

Having been convinced we won't run out of IPv6 addresses, I also prefer 
option 1, keeping ff:ee.

This mean we can safely determine whether an IPv6 address has been 
derived from a short address or a full EUI.   We use this to determine 
whether to use short or extended layer 2 addresses when transmitting.

Daniel.

Jonathan Hui wrote:
> because that's what the reset of the IPv6 addressing architecture tends 
> to assume.
> 
> to close to, but not exactly with RFC 4944?  As I stated before, trying 
> to avoid global-scoped IEEE addresses is a non-issue since short 
> addresses have local scope.
> 
> -- 
> Jonathan Hui
> 
>> have tested interoperability to this day and even less with the use of 
>> short addresses. W.r.t. 6lowpan-hc there was ambiguity over whether or 
>> not to use the PAN ID in the IID. It seems that we need to change 
>> something to better achieve interoperability. There's already 
>> consensus to never include the PAN ID in the IID, so an update to 
>> Section 6 of RFC 4944 is already necessary.
>>
>> In both cases, the prefix and IID is 64 bits. At this point it's just 
>> a matter of how many zeros are involved. It's a minor point, so I 
>> wouldn't dwell on this issue too long.
>>
>> -- 
>> Jonathan Hui
>>

-- 
__________________________________________________
Daniel Gavelle, Software Engineer
Tel: +44 114 281 2655
Fax: +44 114 281 2951
Jennic Ltd, Furnival Street, Sheffield, S1 4QT, UK
Comp Reg No: 3191371  Registered In England
http://www.jennic.com
__________________________________________________

---

From: Jonathan Hui <[email-masked]>
Date: Tue, 30 Mar 2010 10:58:47 -0700

Hi Daniel,

On Mar 30, 2010, at 10:47 AM, Daniel Gavelle wrote:

> derived from a short address or a full EUI.   We use this to  
> determine whether to use short or extended layer 2 addresses when  
> transmitting.

This is a separate issue that we've discussed several times on this  
list.  You are assuming that there is a well-defined mapping between  
IIDs and link-layer addresses in 6lowpan networks.  Currently there is  
no such assumption.

The IPv6 addressing architecture does not make any assumptions about  
the relation between IIDs and link-layer addresses.  The current  
6lowpan-nd and nd-simple drafts maintain this assumption by  
establishing a mapping between IPv6 and link-layer addresses (taking  
the place of address resolution in RFC 4861).

If we continue to make no assumption about the relationship of IIDs  
and link-layer addresses, then you cannot safely assume that an  
'ff:fe' IID was derived from a short address.

--
Jonathan Hui

---

From: Daniel Gavelle <[email-masked]>
Date: Wed, 31 Mar 2010 00:49:12 +0100

Jonathan,

We don't need the ff:fe to distinguish between short and EUI 64 
stateless addresses as the U/L bit discriminates between them. We 
currently use the ff:fe as an extra check.

Once we start using ND or DHCP, we will need to maintain a neighbour 
table and there will be even less need for the ff:fe.  I therefore don't 
object to using IPv6 addrs that have the form aaaa::1:xxxx in a future 
change to 4944.

Daniel.

Jonathan Hui wrote:
> The IPv6 addressing architecture does not make any assumptions about the 
> relation between IIDs and link-layer addresses.  The current 6lowpan-nd 
> and nd-simple drafts maintain this assumption by establishing a mapping 
> between IPv6 and link-layer addresses (taking the place of address 
> resolution in RFC 4861).
> 
> If we continue to make no assumption about the relationship of IIDs and 
> link-layer addresses, then you cannot safely assume that an 'ff:fe' IID 
> was derived from a short address.
> 
> -- 
> Jonathan Hui
> 
>

---

From: Carsten Bormann <[email-masked]>
Date: Wed, 31 Mar 2010 08:59:24 +0200

On Mar 31, 2010, at 01:49, Daniel Gavelle wrote:

> We don't need the ff:fe to distinguish between short and EUI 64 stateless addresses as the U/L bit discriminates between them. 

Well, the U/L bit distinguishes between addresses derived from the globally unique EUI-64 (U bit set) and all other addresses (U bit clear).  The ff:fe00 then is our convention to identify addresses derived from 16-bit MAC addresses.  There may be other, non-globally-unique addresses in use in a LoWPAN (e.g. for address privacy, SEND, ...), even though that may not be the typical deployment case today.

Gruesse, Carsten